Object.defineProperty(exports,"__esModule",{value:true});exports.Button=undefined;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};var _react=require('react');var _react2=_interopRequireDefault(_react);
var _reactNative=require('react-native');





var _index=require('../index');





var _mapPropsToStyles=require('../Base/utils/mapPropsToStyles');var _mapPropsToStyles2=_interopRequireDefault(_mapPropsToStyles);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i];}return target;}

/** Basic button styles **/
var buttonPropsMap={
large:{height:55,px:3},
small:{height:30,px:1},
medium:{height:40,px:2},
default:{
backgroundColor:'midgray',
textColor:'white',
borderColor:'midgray',
underlayColor:'darken'},

primary:{
backgroundColor:'primary',
textColor:'white',
borderColor:'primary',
underlayColor:'darken'},

secondary:{
backgroundColor:'secondary',
textColor:'white',
borderColor:'secondary',
underlayColor:'darken'},

positive:{
backgroundColor:'positive',
textColor:'white',
borderColor:'positive',
underlayColor:'darken'},

negative:{
backgroundColor:'negative',
textColor:'white',
borderColor:'negative',
underlayColor:'darken'},

outline:{
backgroundColor:'transparent',
borderWidth:2,
underlayColor:'#eee',
textColor:'default'},

transparent:{
backgroundColor:'transparent',
borderWidth:0,
borderColor:'transparent',
underlayColor:'transparent',
textColor:'default'}};



/**
 * A basic button that inherits from Base, and provides colourization
 * based upon background color configuration.
 * @Composes Base, Text, Icon
 */

var Button=exports.Button=function Button(_ref)





{var block=_ref.block;var children=_ref.children;var icon=_ref.icon;var disabled=_ref.disabled;var other=_objectWithoutProperties(_ref,['block','children','icon','disabled']);

// determine our basic style props
var defaults=_extends({},buttonPropsMap.medium,buttonPropsMap.default);
var mappedProps=(0,_mapPropsToStyles2.default)(other,buttonPropsMap,defaults);
var textColor=other.outline?
mappedProps.borderColor:
mappedProps.textColor;

// create our text component if necessary
var child=children&&typeof children==='string'?

_react2.default.createElement(_index.Text,{
color:textColor,
large:other.large,
medium:other.medium,
small:other.small},

children):


children;

// create an icon if necessary
var iconNode=icon&&typeof icon==='string'?
_react2.default.createElement(_index.Icon,{name:icon,mr:1,size:25,color:textColor}):
icon;

var traits=['button'];
if(disabled)traits.push('disabled');

return(
_react2.default.createElement(_index.Base,_extends({
Component:_reactNative.TouchableHighlight,
accessibilityComponentType:'button',
accessibilityTraits:traits,
disabled:disabled,
baseStyle:[
styles.button,
block&&styles.block,
disabled&&styles.disabled]},

mappedProps),

_react2.default.createElement(_reactNative.View,{style:styles.buttonContent},
iconNode,
child)));



};

Button.propTypes={

/** button size */
small:_react.PropTypes.bool,
medium:_react.PropTypes.bool,
large:_react.PropTypes.bool,

/** Uses the primary colour to style the button. */
primary:_react.PropTypes.bool,

/** Uses the secondary colour to style the button. */
secondary:_react.PropTypes.bool,

/** Uses the positive colour to style the button. */
positive:_react.PropTypes.bool,

/** Uses the negative colour to style the button. */
negative:_react.PropTypes.bool,

/** Uses the midgray colour to style the button. */
default:_react.PropTypes.bool,

/** Use an outline button style **/
outline:_react.PropTypes.bool,

/** Accepts either a text string or a custom node */
children:_react.PropTypes.node,

/** disables the button, and reduces its opacity */
disabled:_react.PropTypes.bool,
rounded:_react.PropTypes.number,
onPress:_react.PropTypes.func,
underlayColor:_react.PropTypes.string,
backgroundColor:_react.PropTypes.string,
borderColor:_react.PropTypes.string,

/** stretch the button width */
block:_react.PropTypes.bool,

/** optional icon string or node */
icon:_react.PropTypes.oneOfType([_react.PropTypes.string,_react.PropTypes.node])};


Button.displayName='Button';

Button.defaultProps={
size:'medium',
disabled:false,
outline:false,
block:false,
rounded:6};


var styles=_reactNative.StyleSheet.create({
button:{
justifyContent:'space-around',
alignItems:'center',
alignSelf:'flex-start',
borderWidth:2},

disabled:{
opacity:0.2},

block:{
alignSelf:'stretch'},

buttonContent:{
flex:1,
flexDirection:'row',
justifyContent:'center',
alignItems:'center'}});exports.default=



Button;